'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _isString = require('lodash/isString');

var _isString2 = _interopRequireDefault(_isString);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _compose = require('recompose/compose');

var _compose2 = _interopRequireDefault(_compose);

var _setDisplayName = require('recompose/setDisplayName');

var _setDisplayName2 = _interopRequireDefault(_setDisplayName);

var _RockeyHoc = require('./RockeyHoc');

var _htmlTags = require('./htmlTags');

var _htmlTags2 = _interopRequireDefault(_htmlTags);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ucfirst = function ucfirst(s) {
  return s.charAt(0).toUpperCase() + s.slice(1);
};

var RockeyHoc = (0, _RockeyHoc.getRockeyHoc)();

var RecomposeRockeyHoc = function RecomposeRockeyHoc(displayName, BaseComponent) {
  return function () {
    for (var _len = arguments.length, enhacners = Array(_len), _key = 0; _key < _len; _key++) {
      enhacners[_key] = arguments[_key];
    }

    var RecomposeHoc = _compose2.default.apply(undefined, [(0, _setDisplayName2.default)(ucfirst(displayName))].concat(enhacners))(BaseComponent);

    return RockeyHoc(RecomposeHoc, {
      displayName: ucfirst(displayName)
    });
  };
};

var counter = {};

var _loop = function _loop(tag) {
  // ---- tag hoc lazy creation
  Object.defineProperty(RecomposeRockeyHoc, tag, {
    get: function get() {
      return function (displayName) {
        for (var _len2 = arguments.length, enhacners = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          enhacners[_key2 - 1] = arguments[_key2];
        }

        // Use function component instaed of tag string
        // to support look feature - when add splited comopnent
        // as static props to constructor
        var TagComponent = function TagComponent(props) {
          return _react2.default.createElement(tag, props);
        };

        if ((0, _isString2.default)(displayName)) {
          return RecomposeRockeyHoc(ucfirst(displayName), TagComponent).apply(undefined, enhacners);
        } else if ((0, _isFunction2.default)(displayName)) {
          if (!counter[tag]) {
            counter[tag] = 0;
          }

          return RecomposeRockeyHoc('RecomposeShortcut' + ucfirst(tag) + ++counter[tag], TagComponent).apply(undefined, [displayName].concat(enhacners));
        } else {
          throw new Error('wrong usage');
        }
      };
    },
    set: function set() {
      throw new Error('Override default RockeyHoc shorcuts is disabled');
    }
  });
};

var _iteratorNormalCompletion = true;
var _didIteratorError = false;
var _iteratorError = undefined;

try {
  for (var _iterator = _htmlTags2.default[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
    var tag = _step.value;

    _loop(tag);
  }
} catch (err) {
  _didIteratorError = true;
  _iteratorError = err;
} finally {
  try {
    if (!_iteratorNormalCompletion && _iterator.return) {
      _iterator.return();
    }
  } finally {
    if (_didIteratorError) {
      throw _iteratorError;
    }
  }
}

exports.default = RecomposeRockeyHoc;